"""Verbose HTTP exceptions."""

from verbose_http_exceptions import status as status
from verbose_http_exceptions.exc import *  # noqa: F403
from verbose_http_exceptions.warns import (
    IncorrectExceptionUsageWarning as IncorrectExceptionUsageWarning,
)

error_by_status_mapping: dict[int, type[BaseVerboseHTTPException]] = {
    status.HTTP_100_CONTINUE: ContinueHTTPException,
    status.HTTP_101_SWITCHING_PROTOCOLS: SwitchingProtocolsHTTPException,
    status.HTTP_102_PROCESSING: ProcessingHTTPException,
    status.HTTP_103_EARLY_HINTS: EarlyHintsHTTPException,
    status.HTTP_200_OK: OkHTTPException,
    status.HTTP_201_CREATED: CreatedHTTPException,
    status.HTTP_202_ACCEPTED: AcceptedHTTPException,
    status.HTTP_203_NON_AUTHORITATIVE_INFORMATION: NonAuthoritativeInformationHTTPException,
    status.HTTP_205_RESET_CONTENT: ResetContentHTTPException,
    status.HTTP_206_PARTIAL_CONTENT: PartialContentHTTPException,
    status.HTTP_207_MULTI_STATUS: MultiStatusHTTPException,
    status.HTTP_208_ALREADY_REPORTED: AlreadyReportedHTTPException,
    status.HTTP_226_IM_USED: IMUsedHTTPException,
    status.HTTP_300_MULTIPLE_CHOICES: MultipleChoicesHTTPException,
    status.HTTP_301_MOVED_PERMANENTLY: MovedPermanentlyHTTPException,
    status.HTTP_302_FOUND: FoundHTTPException,
    status.HTTP_303_SEE_OTHER: SeeOtherHTTPException,
    status.HTTP_304_NOT_MODIFIED: NotModifiedHTTPException,
    status.HTTP_305_USE_PROXY: UseProxyHTTPException,
    status.HTTP_306_UNUSED: UnusedHTTPException,
    status.HTTP_307_TEMPORARY_REDIRECT: TemporaryRedirectHTTPException,
    status.HTTP_308_PERMANENT_REDIRECT: PermanentRedirectHTTPException,
    status.HTTP_400_BAD_REQUEST: BadRequestHTTPException,
    status.HTTP_401_UNAUTHORIZED: UnauthorizedHTTPException,
    status.HTTP_402_PAYMENT_REQUIRED: PaymentRequiredHTTPException,
    status.HTTP_403_FORBIDDEN: ForbiddenHTTPException,
    status.HTTP_404_NOT_FOUND: NotFoundHTTPException,
    status.HTTP_405_METHOD_NOT_ALLOWED: MethodNotAllowedHTTPException,
    status.HTTP_406_NOT_ACCEPTABLE: NotAcceptableHTTPException,
    status.HTTP_407_PROXY_AUTHENTICATION_REQUIRED: ProxyAuthenticationRequiredHTTPException,
    status.HTTP_408_REQUEST_TIMEOUT: RequestTimeoutHTTPException,
    status.HTTP_409_CONFLICT: ConflictHTTPException,
    status.HTTP_410_GONE: GoneHTTPException,
    status.HTTP_411_LENGTH_REQUIRED: LengthRequiredHTTPException,
    status.HTTP_412_PRECONDITION_FAILED: PreconditionFailedHTTPException,
    status.HTTP_413_PAYLOAD_TOO_LARGE: PayloadTooLargeHTTPException,
    status.HTTP_414_URI_TOO_LONG: UriTooLongHTTPException,
    status.HTTP_415_UNSUPPORTED_MEDIA_TYPE: UnsupportedMediaTypeHTTPException,
    status.HTTP_416_RANGE_NOT_SATISFIABLE: RangeNotSatisfiableHTTPException,
    status.HTTP_417_EXPECTATION_FAILED: ExpectationFailedHTTPException,
    status.HTTP_418_IM_A_TEAPOT: ImATeapotHTTPException,
    status.HTTP_421_MISDIRECTED_REQUEST: MisdirectedRequestHTTPException,
    status.HTTP_422_UNPROCESSABLE_CONTENT: UnprocessableContentHTTPException,
    status.HTTP_423_LOCKED: LockedHTTPException,
    status.HTTP_424_FAILED_DEPENDENCY: FailedDependencyHTTPException,
    status.HTTP_425_TOO_EARLY: TooEarlyHTTPException,
    status.HTTP_426_UPGRADE_REQUIRED: UpgradeRequiredHTTPException,
    status.HTTP_428_PRECONDITION_REQUIRED: PreconditionRequiredHTTPException,
    status.HTTP_429_TOO_MANY_REQUESTS: TooManyRequestsHTTPException,
    status.HTTP_431_REQUEST_HEADER_FIELDS_TOO_LARGE: RequestHeaderFieldsTooLargeHTTPException,
    status.HTTP_451_UNAVAILABLE_FOR_LEGAL_REASONS: UnavailableForLegalReasonHTTPException,
    status.HTTP_500_INTERNAL_SERVER_ERROR: InternalServerErrorHTTPException,
    status.HTTP_501_NOT_IMPLEMENTED: NotImplementedHTTPException,
    status.HTTP_502_BAD_GATEWAY: BadGatewayHTTPException,
    status.HTTP_503_SERVICE_UNAVAILABLE: ServiceUnavailableHTTPException,
    status.HTTP_504_GATEWAY_TIMEOUT: GatewayTimeoutHTTPException,
    status.HTTP_505_HTTP_VERSION_NOT_SUPPORTED: VersionNotSupportedHTTPException,
    status.HTTP_506_VARIANT_ALSO_NEGOTIATES: VariantAlsoNegotiatesHTTPException,
    status.HTTP_507_INSUFFICIENT_STORAGE: InsufficientStorageHTTPException,
    status.HTTP_508_LOOP_DETECTED: LoopDetectedHTTPException,
    status.HTTP_510_NOT_EXTENDED: NotExtendedHTTPException,
    status.HTTP_511_NETWORK_AUTHENTICATION_REQUIRED: NetworkAuthenticationRequiredHTTPException,
}
